## ycmd 0%2B20160327%2Bgitc3e6904

=== debian/changelog ===
ycmd (0+20160327+gitc3e6904-1) unstable; urgency=low

  * New upstream release. (Closes: #818070)
  * Refresh patches for new upstream release.
  * Add libclang-3.8-dev and remove libclang-dev from Build-Depends.

 -- Onur Aslan <onur@onur.im>  Sat, 09 Apr 2016 12:22:30 +0300

ycmd (0+20160303+git206efaf-1) unstable; urgency=low

  * New upstream release. (Closes: #818070)
  * Bump Standards-Version to 3.9.7 (no changes).
  * Refresh patches for new upstream version.
  * Add copyright info for third_party/JediHTTP.
  * Exclude javascript and rust tests.
  * Install JediHTTP into usr/lib/ycmd/third_party/.
  * Update 01-python-path.patch to remove AddVendorFolderToSysPath
    function from jedihttp. This package is using system packages for
    jedihttp dependencies.
  * Update d/rules get-orig-source to update only required submodules
    instead of cloning repository recursively.
  * Add python3-nose, python3-hamcrest, python3-webtest, python3-jedi,
    python3-waitress, python3-bottle, python3-requests into Build-Depends 
    for JediHTTP tests.
  * Update d/rules override_dh_auto_test to run JediHTTP tests.
  * Update d/rules override_dh_install to remove JediHTTP tests.
  * Add 05-tern-support.patch to support local node-tern installation.
  * Add python-future, python-pep8 and python-setuptools into
    Build-Depends.
  * Add python-future into Depends.
  * Update 03-gocode-path.patch to remove unused import to get rid of
    flake8 error.
  * Remove golang dependencies and exclude golang tests. ycmd started using
    godef along with gocode, and godef is not available for Debian. golang
    completion is temporary disabled. Users can still use golang
    completion by installing gocode package and putting godef executable
    into /usr/bin/godef or setting godef_binary_path in
    default_settings.json.
  * Set HOME environment variable to $(CURDIR) when running tests.
  * Update d/rules override_dh_auto_clean to remove .noseids and .cache
    directories generated by nosetests.
  * Use HTTPS URI's for Vcs-Git and Vcs-Browser fields.
  * Add README.Debian to provide additional information about supported
    completion engines.
  * Add 06-omnisharp-path.patch to give optional OmniSharp based C#
    additional support.
  * Replace python-flake8 dependency with flake8. (Closes: #818453)
  * Add 07-shebang.patch to add missing script headers to main executable
    file and check_core_version.py.
  * Remove executable permission from some completer modules.

 -- Onur Aslan <onur@onur.im>  Tue, 29 Mar 2016 14:09:34 +0300

ycmd (0+20151019+git0825f85-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches for new upstream version.
  * Remove 04-test-basic-string-alias.patch. Fixed in upstream.
  * Update override_dh_auto_clean to remove *.so* files in d/rules.
  * Update override_dh_auto_test to run ./run_tests.py in d/rules.
  * Install CORE_VERSION instead of EXPECTED_CORE_VERSION.
  * Create a symbolic link to clang includes directory in
    /usr/lib/ycmd. (Closes: #800618)
  * Add libclang-common-(CLANG_VER)-dev into recommends.
  * Replace libclang-3.(6|7) dependencies with libclang-dev (>= 3.6) to
    use default clang version provided by llvm-defaults.
  * Add typescript support:
    - Add node-typescript into Build-Depends and Recommends.
    - Add 04-tsserver-path.patch to use node-typescript for typescript
      completion.
    - Remove excluded typescript tests to activate typescript tests in
      d/rules.
  * Update 00-build-system.patch to add support for libclang-3.8-dev.
  * Update 02-generic-ycm-extra-conf-py.patch to simplify
    ycm_extra_conf.py.

 -- Onur Aslan <onur@onur.im>  Mon, 02 Nov 2015 13:40:20 +0300

ycmd (0+20150804+git6f4dbb4-1) unstable; urgency=low

  * New upstream release.
  * Refresh patches for new upstream version.
  * Replace libclang-dev build dependency with
    libclang-3.6-dev | libclang3.7-dev.
  * Remove clang-3.5 support in 00-build-system.patch.
  * Add 04-test-basic-string-alias.patch.
  * Update d/install to install EXPECTED_CORE_VERSION and
    check_core_version.py
  * Update Upstream-Name and Source URL in debian/copyright.
  * Update copyright info and years.

 -- Onur Aslan <onur@onur.im>  Fri, 07 Aug 2015 12:10:08 +0300

ycmd (0+20150616+gitd7a3653-1) unstable; urgency=low

  * Initial release. (Closes: #771330)

 -- Onur Aslan <onur@onur.im>  Mon, 22 Jun 2015 20:06:43 +0300

## ycmd 0%2B20191222%2Bgit2771f6f%2Bds

=== examples/requirements.txt ===
enum34>=1.0
requests>=2.5.1
httpie>=0.5.0

## ycmd 0%2B20230103%2Bgitf53e7ac%2Bds

=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: David Kalnischkies <donkult@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libabsl-dev,
               libclang-dev (>= 1:9.0),
               libgtest-dev,
               libgmock-dev,
               libwhereami-dev,
               pybind11-dev (>= 2.3.0),
               python3-dev,
               python3-regex,
               unicode-data (>= 13.0.0),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://ycm-core.github.io/ycmd/
Vcs-Git: https://salsa.debian.org/debian/ycmd.git
Vcs-Browser: https://salsa.debian.org/debian/ycmd

Package: ycmd
Architecture: any
Depends: python3-bottle,
         python3-frozendict,
         python3-future,
         python3-jedi (>= 0.16.0),
         python3-watchdog,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: libclang-common-${misc:Clang-Ver}-dev, vim-youcompleteme
Suggests: ccls, clangd, fortran-language-server, gopls, node-typescript
Provides: ycmd-core-version (= ${misc:Core-Ver}), ycmd-core-version (= 47)
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.

## ycmd 0%2B20231230%2Bgit9e43034%2Bds

=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: David Kalnischkies <donkult@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libabsl-dev (>= 20220623.1-3.1),
               libclang-dev (>= 1:9.0),
               libgtest-dev,
               libgmock-dev,
               libwhereami-dev,
               pybind11-dev (>= 2.3.0),
               python3-dev,
               python3-regex,
               unicode-data (>= 13.0.0),
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://ycm-core.github.io/ycmd/
Vcs-Git: https://salsa.debian.org/debian/ycmd.git
Vcs-Browser: https://salsa.debian.org/debian/ycmd

Package: ycmd
Architecture: any
Depends: python3-bottle,
         python3-frozendict,
         python3-jedi (>= 0.16.0),
         python3-watchdog,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: libclang-common-${misc:Clang-Ver}-dev, vim-youcompleteme
Suggests: ccls, clangd, fortran-language-server, godot3, gopls, node-typescript
Provides: ycmd-core-version (= ${misc:Core-Ver}), ycmd-core-version (= 48)
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.

## ycmd 0%2B20240823%2Bgit8b61f19%2Bds

=== debian/changelog ===
ycmd (0+20240823+git8b61f19+ds-2+nmu1~cc1~trixie) testing; urgency=medium

  * Rebuild for new libllvm

 -- Caoimhe Chaos <caoimhechaos@protonmail.com>  Sun, 19 Jan 2025 04:42:34 +0100

ycmd (0+20240823+git8b61f19+ds-2) unstable; urgency=medium

  * Import upstream 0+20241013+gitd8c3b69 as patch series
  * Prefer clangd-19 if we need to pick a versioned clangd
  * Wait for tssserver termination also for 30 seconds

 -- David Kalnischkies <donkult@debian.org>  Tue, 22 Oct 2024 13:00:33 +0200

ycmd (0+20240823+git8b61f19+ds-1) unstable; urgency=medium

  * New upstream version 0+20240823+git8b61f19+ds
    - Refresh patches
  * Bump Standards-Version to 4.7.0 (no change needed)

 -- David Kalnischkies <donkult@debian.org>  Tue, 10 Sep 2024 18:16:51 +0200

ycmd (0+20240618+gite81c15e+ds-1) unstable; urgency=medium

  * New upstream version 0+20240618+gite81c15e+ds
    - Support for type/call hierarchy commands
    - Refresh patches
  * Restore support for older tsserver in tests
  * Skip go tests failing with golang-golang-x-tools 0.20 (gopls)

 -- David Kalnischkies <donkult@debian.org>  Wed, 19 Jun 2024 11:24:19 +0200

ycmd (0+20240401+gitda9c643+ds-1) unstable; urgency=medium

  * New upstream version 0+20240401+gitda9c643+ds
    - Refresh patches and tests
    - Drop now unused python3-{bottle,frozendict} dependencies
  * Prefer versioned clangd-18 over -17 (and older)
  * Include License Header for Apache-2.0 in d/copyright
  * Bump upstream copyright years to 2024 for newly added file
  * Support debian/ files (debputy) completion out of the box
  * Avoid needless internal CORE_VERSION enforcement

 -- David Kalnischkies <donkult@debian.org>  Fri, 05 Apr 2024 22:07:53 +0200

ycmd (0+20231230+git9e43034+ds-2) unstable; urgency=medium

  * Import upstream 0+20240217+gitb63d2e8 as patch series
    - Fixing tests for go v1.22.0 (Closes: #1064498)

 -- David Kalnischkies <donkult@debian.org>  Sat, 24 Feb 2024 12:07:29 +0100

ycmd (0+20231230+git9e43034+ds-1) unstable; urgency=medium

  [ David Kalnischkies ]
  * New upstream version 0+20231230+git9e43034+ds
    - Refresh patches and drop backported ones
  * Bump my copyright year as advised by lintian

  [ Alexandre Detiste ]
  * Remove extraneous obsolete dependency on python3-future (Closes: #1058019)

 -- David Kalnischkies <donkult@debian.org>  Wed, 03 Jan 2024 00:44:54 +0100

ycmd (0+20230611+git3392251+ds-2) unstable; urgency=medium

  * Import upstream 0+20231029+git62cfc45 as patch series
    - Support clang 17 (from experimental) in autopkgtests
  * Prefer upstream-blessed clangd-17 before other versioned clangs
  * Import upstream PR1719 to support Unicode 15.1 (Closes: #1052804)

 -- David Kalnischkies <donkult@debian.org>  Sun, 05 Nov 2023 11:41:38 +0100

ycmd (0+20230611+git3392251+ds-1) unstable; urgency=medium

  * New upstream version 0+20230611+git3392251+ds
    - Refresh patches
    - Make tests compatible with golang-1.20 (Closes: #1037480)
  * Support GDScript (Godot) completion out of the box
  * Prefer upstream-blessed clangd-16 before other versioned clangs
  * Drop as-needed linker flag from debian/rules (lintian)
  * Bump Standards-Version to 4.6.2 (no change needed)

 -- David Kalnischkies <donkult@debian.org>  Wed, 21 Jun 2023 14:05:18 +0200

ycmd (0+20230103+gitf53e7ac+ds-1) unstable; urgency=medium

  * New upstream version 0+20230103+gitf53e7ac+ds
    - implements support for clangd GoToAlternateFile
  * Let service management test wait longer for termination
  * Do not check text of AttributeErrors raised in tests
  * add Repository field in upstream/metadata

 -- David Kalnischkies <donkult@debian.org>  Sat, 14 Jan 2023 16:21:53 +0100

ycmd (0+20220824+git2ee4100+ds-2) unstable; urgency=medium

  * Import upstream 0+20220929+git0e13fec+ds as patch series
    - Keep CORE_VERSION at 45, but provide 47 as well
    - Refresh, rename & reorganize patches
  * Prefer using clangd before clangd-15 over -14, -13 and -16
  * Increase tsserver timeout from 20 to 30 seconds (for armel)
  * Ignore "too slow" failure of clangd FixIt_AlreadyResolved test

 -- David Kalnischkies <donkult@debian.org>  Sun, 16 Oct 2022 11:55:37 +0200

ycmd (0+20220824+git2ee4100+ds-1) unstable; urgency=medium

  * New upstream version 0+20220824+git2ee4100+ds
    - Adds highly experimental inlet hints support
  * Relax clangd fixit matcher for clangd-15
  * Split out tests requiring nodejs into own autopkgtest

 -- David Kalnischkies <donkult@debian.org>  Fri, 26 Aug 2022 19:24:36 +0200

ycmd (0+20220401+gitdbe806f+ds-3) unstable; urgency=medium

  * Import upstream 0+20220609+git20bfbbf as patch series
    - Support for semantic highlighting (experimental)
    - Support for the basic workspace folders in LSP completers
  * Support LSP textDocumentSyncKind
  * Describe state of Fortran completer support better
  * Accept different format fixits from newer gopls in test (Closes: #1016838)
  * Ignore unpaired UTF-8 bidirectional warning from UnicodeTable.inc
  * Rerun go tests on golang as well
  * Drop explicit clangd-14 from test dependencies

 -- David Kalnischkies <donkult@debian.org>  Mon, 08 Aug 2022 19:17:59 +0200

ycmd (0+20220401+gitdbe806f+ds-2) unstable; urgency=medium

  * Import upstream version 0+20220609+git20bfbbf+ds as patch:
    - Allow generic LSP completers to override built in completers
  * Ignore order of Goto locations return by clangd in autopkgtest
  * Update Fortran Language Server definition from lsp-examples

 -- David Kalnischkies <donkult@debian.org>  Fri, 10 Jun 2022 22:45:57 +0200

ycmd (0+20220401+gitdbe806f+ds-1) unstable; urgency=medium

  * New upstream version 0+20220401+gitdbe806f+ds
    - Refresh patches & drop backported upstream patches
    - Remove python3-requests dep
    - Remove python3-waitress dep
    - Add libabsl-dev dep and use it
    - Upstream Core-Version is now 45, drop 42 compat
    - Update copyright for upstream release


## ycmd 0%2b20150804%2bgit6f4dbb4

=== cpp/CMakeLists.txt ===
# Copyright (C) 2011, 2012  Google Inc.
#
# This file is part of YouCompleteMe.
#
# YouCompleteMe is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# YouCompleteMe is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with YouCompleteMe.  If not, see <http://www.gnu.org/licenses/>.

if ( DEFINED ENV{TRAVIS} )
  # We lie to Travis CI about the min CMake version we need. For what we use
  # Travis for, the old version of CMake that it has is good enough.
  cmake_minimum_required( VERSION 2.8 )
else()
  if ( APPLE )
    # OSX requires CMake >= 2.8.12, see YCM issue #1439
    cmake_minimum_required( VERSION 2.8.12 )
  else()
    # CMake 2.8.11 is the latest available version on RHEL/CentOS 7
    cmake_minimum_required( VERSION 2.8.11 )
  endif()
endif()


# Disable CMake legacy mode for Cygwin, since the build doesn't depend on
# WIN32 being set for Cygwin, and this property being unset causes a
# warning in Cygwin.
# Remove when CMake >= 2.8.4 is required, since that implicitly sets this
set( CMAKE_LEGACY_CYGWIN_WIN32 0 )

project( YouCompleteMe )

option( UNIVERSAL "Build universal mac binary" OFF )

if ( CMAKE_GENERATOR STREQUAL Xcode )
  set( CMAKE_GENERATOR_IS_XCODE true )
endif()

if ( ${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD" )
  set( SYSTEM_IS_FREEBSD true )
endif()

if ( ${CMAKE_SYSTEM_NAME} MATCHES "OpenBSD" )
  set( SYSTEM_IS_OPENBSD true )
endif()

if ( ${CMAKE_SYSTEM_NAME} MATCHES "SunOS" )
  set( SYSTEM_IS_SUNOS true )
endif()

# Check if platform is 64 bit
if( CMAKE_SIZEOF_VOID_P EQUAL 4 )
  set( 64_BIT_PLATFORM 0 )
else()
  set( 64_BIT_PLATFORM 1 )
endif()

#############################################################################

# Turning on this flag tells cmake to emit a compile_commands.json file.
# This file can be used to load compilation flags into YCM. See here for more
# details: http://clang.llvm.org/docs/JSONCompilationDatabase.html
set( CMAKE_EXPORT_COMPILE_COMMANDS 1 )

#############################################################################

# This is needed so that on macs, the library is built in both 32 bit and 64 bit
# versions. Without this python might refuse to load the module, depending on
# how python was built.
# On Mac, boost needs to be compiled universal as well, if used instead of the
# included BoostParts lib. For brew, that's
# "brew install boost --universal"
# If the user chose to use the system libclang.dylib (or the libclang.dylib
# binary downloaded from llvm.org) on a mac, then we don't specify universal
# binary building since the system libclang on macs is not  universal (and thus
# linking would fail with universal).
if ( UNIVERSAL AND NOT USE_SYSTEM_LIBCLANG )
  set( CMAKE_OSX_ARCHITECTURES "i386;x86_64" )
endif()

#############################################################################

# To shut up the warning about CMake policy CMP0042
set( CMAKE_MACOSX_RPATH ON )

#############################################################################

if ( CMAKE_CXX_COMPILER_ID STREQUAL "Clang" )
  set( COMPILER_IS_CLANG true )

  # Linux machines don't necessarily have libc++ installed alongside clang,
  # but HAS_LIBCXX11 doesn't always trigger for machines that DO have libc++. We
  # know that at least all the Mac OS versions we support that use Clang have
  # libc++, so we're safe there. On FreeBSD 9 libc++ is an optional build
  # toggle. On FreeBSD 10 it is the default.
  if ( HAS_LIBCXX11 OR APPLE OR SYSTEM_IS_FREEBSD )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++" )
  endif()

  # Ninja will by default prevent Clang from outputting diagnostics in color, so
  # we force color output
  if ( CMAKE_GENERATOR STREQUAL "Ninja" )
    set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fcolor-diagnostics" )
  endif()
endif()

#############################################################################

# Force release build by default, speed is of the essence
if ( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release )
endif()

#############################################################################

# Determining the presence of C++11 support in the compiler
set( CPP11_AVAILABLE false )
if ( CMAKE_COMPILER_IS_GNUCXX )
  execute_process(
    COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
  if ( GCC_VERSION VERSION_GREATER 4.6 OR GCC_VERSION VERSION_EQUAL 4.6 )
    set( CPP11_AVAILABLE true )
  endif()
elseif( COMPILER_IS_CLANG )
  set( CPP11_AVAILABLE true )
  set( CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11" )
  set( CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++" )
endif()

#############################################################################

# For MSVC enable UNICODE and compilation on multiple processors
if ( MSVC )
  add_definitions( /DUNICODE /D_UNICODE /Zc:wchar_t-  )
	set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP" )
endif()

# Solves the conflict in names of hypot in python sources and boost::python
if ( MINGW )
  set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -include cmath")
endif()

# Due to a bug/misconfiguration/stupidity, boost 1.52 and libc++ don't like each
# other much: a compilation error "Constexpr function never produces a constant
# expression" pops up when trying to compile anything that uses
# boost/chrono/duration.hpp (namely boost/thread for us). This is a workaround
# that prevents this from happening. Also present in cpp/BoostParts/CMakeLists.txt.
# See here for more details: https://svn.boost.org/trac/boost/ticket/7671
# TODO: remove this when it's fixed upstream (probably boost 1.53).
add_definitions( -DBOOST_THREAD_DONT_USE_CHRONO )

if( MSVC OR CYGWIN )
  # BOOST_ALL_NO_LIB turns off MSVC library autolinking
  add_definitions( -DBOOST_ALL_NO_LIB )
endif()

if( WIN32 OR CYGWIN )
  # BOOST_PYTHON_SOURCE makes boost use the correct __declspec
  add_definitions( -DBOOST_PYTHON_SOURCE -DBOOST_THREAD_USE_LIB )
  if ( 64_BIT_PLATFORM )
    # Enables python compilation for 64-bit Windows
    add_definitions( -DMS_WIN64 )
  endif()
endif()

#############################################################################

# When used with Clang, adding the -std=c++0x flag to CMAKE_CXX_FLAGS will cause
# the compiler to output a warning during linking:
#  clang: warning: argument unused during compilation: '-std=c++0x'
# This is caused by cmake passing this flag to the linking stage which it
# shouldn't do. It's ignored so it does no harm, but the warning is annoying.
#
# Putting the flag in add_definitions() works around the issue, even though it
# shouldn't in theory go there.
if ( CPP11_AVAILABLE )
  message( "Your C++ compiler supports C++11, compiling in that mode." )

  # Cygwin needs its hand held a bit; see issue #473
  if ( CYGWIN AND CMAKE_COMPILER_IS_GNUCXX )
    add_definitions( -std=gnu++0x )
  else()
    add_definitions( -std=c++0x )
  endif()
else()
  message(
    "Your C++ compiler does NOT support C++11, compiling in C++03 mode." )
endif()

option( USE_SYSTEM_BOOST "Set to ON to use the system boost libraries" OFF )

if (NOT USE_SYSTEM_BOOST)
  add_subdirectory( BoostParts )
endif()

add_subdirectory( ycm )

=== cpp/ycm/CMakeLists.txt ===
# Copyright (C) 2011, 2012  Google Inc.
#
# This file is part of YouCompleteMe.
#
# YouCompleteMe is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# YouCompleteMe is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with YouCompleteMe.  If not, see <http://www.gnu.org/licenses/>.

cmake_minimum_required( VERSION 2.8.7 )

project( ycm_support_libs )
set( CLIENT_LIB "ycm_client_support" )
set( SERVER_LIB "ycm_core" )

set( Python_ADDITIONAL_VERSIONS 2.7 2.6 )
find_package( PythonLibs 2.6 REQUIRED )
# The version of PythonInterp controls the version of boost.python which
# is pulled in later, otherwise the highest python version is used
find_package( PythonInterp 2.6 REQUIRED )

if ( NOT PYTHONLIBS_VERSION_STRING VERSION_LESS "3.0.0" )
  message( FATAL_ERROR
    "CMake found python3 libs instead of python2 libs. YCM works only with "
    "python2.\n" )
endif()

option( USE_DEV_FLAGS "Use compilation flags meant for YCM developers" OFF )
option( USE_CLANG_COMPLETER "Use Clang semantic completer for C/C++/ObjC" OFF )
option( USE_SYSTEM_LIBCLANG "Set to ON to use the system libclang library" OFF )
set( PATH_TO_LLVM_ROOT "" CACHE PATH "Path to the root of a LLVM+Clang binary distribution" )
set( EXTERNAL_LIBCLANG_PATH "" CACHE PATH "Path to the libclang library to use" )

if ( USE_CLANG_COMPLETER AND
     NOT USE_SYSTEM_LIBCLANG AND
     NOT PATH_TO_LLVM_ROOT AND
     NOT EXTERNAL_LIBCLANG_PATH )

  if ( APPLE )
    set( CLANG_DIRNAME "clang+llvm-3.6.2-x86_64-apple-darwin" )
    set( CLANG_SHA256
         "a796b60dbdf849a946ba142f7c05233975ec85bc04468a88e920dee02542a77d" )
    set( CLANG_FILENAME "${CLANG_DIRNAME}.tar.xz" )
  else()
    if ( 64_BIT_PLATFORM )
      # We MUST support the latest Ubuntu LTS release!
      # At the time of writing, that's 14.04. Switch to next LTS ~6 months after
      # it comes out.
      set( CLANG_DIRNAME "clang+llvm-3.6.2-x86_64-linux-gnu-ubuntu-14.04" )
      set( CLANG_SHA256
           "70ff742456459ecad363462c72cba00aaa5473f699da29a2a6125ee7edfb967a" )
      set( CLANG_FILENAME "${CLANG_DIRNAME}.tar.xz" )
    else()
      # Clang 3.3 is the last version with pre-built x86 binaries upstream.
      # That's too old now.
      message( FATAL_ERROR "No pre-built Clang 3.6 binaries for 32 bit linux. "
        "You'll have to compile Clang 3.6 from source. "
        "See the YCM docs for details on how to use a user-compiled libclang." )
    endif()
  endif()

  # Check if the Clang archive is already downloaded and its checksum is correct.
  # If this is not the case, remove it if needed and download it.
  set( CLANG_DOWNLOAD ON )
  set( CLANG_LOCAL_FILE
       "${CMAKE_SOURCE_DIR}/../clang_archives/${CLANG_FILENAME}" )

  if( EXISTS "${CLANG_LOCAL_FILE}" )
    file( SHA256 "${CLANG_LOCAL_FILE}" CLANG_LOCAL_SHA256 )

    if( "${CLANG_LOCAL_SHA256}" STREQUAL "${CLANG_SHA256}" )
      set( CLANG_DOWNLOAD OFF )
    else()
      file( REMOVE "${CLANG_LOCAL_FILE}" )
    endif()
  endif()

  if( CLANG_DOWNLOAD )
    message( "Downloading Clang 3.6.2" )

    set( CLANG_URL "http://llvm.org/releases/3.6.2" )
    file(
      DOWNLOAD "${CLANG_URL}/${CLANG_FILENAME}" "${CLANG_LOCAL_FILE}"
      SHOW_PROGRESS EXPECTED_HASH SHA256=${CLANG_SHA256}
    )
  else()
    message( "Using Clang archive: ${CLANG_LOCAL_FILE}" )
  endif()

  # Copy and extract the Clang archive in the building directory.
  file( COPY "${CLANG_LOCAL_FILE}" DESTINATION "${CMAKE_CURRENT_BINARY_DIR}/../" )
  if ( CLANG_FILENAME MATCHES ".+bz2" )
    execute_process( COMMAND tar -xjf ${CLANG_FILENAME} )
  elseif( CLANG_FILENAME MATCHES ".+xz" )
    execute_process( COMMAND tar -xJf ${CLANG_FILENAME} )
  else()
    execute_process( COMMAND tar -xzf ${CLANG_FILENAME} )
  endif()

  # We need to set PATH_TO_LLVM_ROOT. To do that, we first have to find the
  # folder name the archive produced. It isn't the archive base name.
  execute_process( COMMAND
    find ${CMAKE_CURRENT_BINARY_DIR}/.. -maxdepth 1 -type d -name clang*
    OUTPUT_VARIABLE PATH_TO_LLVM_ROOT
    OUTPUT_STRIP_TRAILING_WHITESPACE )
endif()

if ( PATH_TO_LLVM_ROOT OR USE_SYSTEM_LIBCLANG OR EXTERNAL_LIBCLANG_PATH )
  set( USE_CLANG_COMPLETER TRUE )
endif()

if ( USE_CLANG_COMPLETER AND
     NOT PATH_TO_LLVM_ROOT AND
     NOT USE_SYSTEM_LIBCLANG AND
     NOT EXTERNAL_LIBCLANG_PATH )
  message( FATAL_ERROR
    "You have not specified which libclang to use. You have several options:\n"
    " 1. Set PATH_TO_LLVM_ROOT to a path to the root of a LLVM+Clang binary "
    "distribution. You can download such a binary distro from llvm.org. This "
    "is the recommended approach.\n"
    " 2. Set USE_SYSTEM_LIBCLANG to ON; this makes YCM search for the system "
    "version of libclang.\n"
    " 3. Set EXTERNAL_LIBCLANG_PATH to a path to whatever "
    "libclang.[so|dylib|dll] you wish to use.\n"
    "You HAVE to pick one option. See the docs for more information.")
endif()

if ( USE_CLANG_COMPLETER )
  message( "Using libclang to provide semantic completion for C/C++/ObjC" )
else()
  message( "NOT using libclang, no semantic completion for C/C++/ObjC will be "
           "available" )
endif()

if ( PATH_TO_LLVM_ROOT )
  set( CLANG_INCLUDES_DIR "${PATH_TO_LLVM_ROOT}/include" )
else()
  set( CLANG_INCLUDES_DIR "${CMAKE_SOURCE_DIR}/llvm/include" )
endif()

if ( NOT IS_ABSOLUTE "${CLANG_INCLUDES_DIR}" )
  get_filename_component(CLANG_INCLUDES_DIR
    "${CMAKE_BINARY_DIR}/${CLANG_INCLUDES_DIR}" ABSOLUTE)
endif()

if ( NOT EXTERNAL_LIBCLANG_PATH AND PATH_TO_LLVM_ROOT )
  if ( MINGW )
    set( LIBCLANG_SEARCH_PATH "${PATH_TO_LLVM_ROOT}/bin" )
  else()
    set( LIBCLANG_SEARCH_PATH "${PATH_TO_LLVM_ROOT}/lib" )
  endif()

  # Need TEMP because find_library does not work with an option variable
  find_library( TEMP NAMES clang libclang
                PATHS ${LIBCLANG_SEARCH_PATH}
                NO_DEFAULT_PATH )
  set( EXTERNAL_LIBCLANG_PATH ${TEMP} )
endif()

# This is a workaround for a CMake bug with include_directories(SYSTEM ...)
# on Mac OS X. Bug report: http://public.kitware.com/Bug/view.php?id=10837
if ( APPLE )
  set( CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem " )
endif()

if ( USE_SYSTEM_BOOST )
  find_package( Boost REQUIRED COMPONENTS python filesystem system regex thread )
else()
  set( Boost_INCLUDE_DIR ${BoostParts_SOURCE_DIR} )
  set( Boost_LIBRARIES BoostParts )
endif()

# The SYSTEM flag makes sure that -isystem[header path] is passed to the
# compiler instead of the standard -I[header path]. Headers included with
# -isystem do not generate warnings (and they shouldn't; e.g. boost warnings are
# just noise for us since we won't be changing them).
include_directories(
  SYSTEM
  ${Boost_INCLUDE_DIR}
  ${PYTHON_INCLUDE_DIRS}
  ${CLANG_INCLUDES_DIR}
  )

file( GLOB_RECURSE SERVER_SOURCES *.h *.cpp )

# The test sources are a part of a different target, so we remove them
# The CMakeFiles cpp file is picked up when the user creates an in-source build,
# and we don't want that. We also remove client-specific code
file( GLOB_RECURSE to_remove tests/*.h tests/*.cpp CMakeFiles/*.cpp *client* )

if( to_remove )
  list( REMOVE_ITEM SERVER_SOURCES ${to_remove} )
endif()

if ( USE_CLANG_COMPLETER )
  include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    "${CMAKE_CURRENT_SOURCE_DIR}/ClangCompleter" )
  add_definitions( -DUSE_CLANG_COMPLETER )
else()
  file( GLOB_RECURSE to_remove_clang ClangCompleter/*.h ClangCompleter/*.cpp )

  if( to_remove_clang )
    list( REMOVE_ITEM SERVER_SOURCES ${to_remove_clang} )
  endif()
endif()

#############################################################################

# One can use the system libclang.[so|dylib] like so:
#   cmake -DUSE_SYSTEM_LIBCLANG=1 [...]
# One can also explicitely pick the external libclang.[so|dylib] for use like so:
#   cmake -DEXTERNAL_LIBCLANG_PATH=/path/to/libclang.so [...]
# The final .so we build will then first look in the same dir in which it is
# located for libclang.so. This is provided by the rpath = $ORIGIN feature.

if ( EXTERNAL_LIBCLANG_PATH OR USE_SYSTEM_LIBCLANG )
  if ( USE_SYSTEM_LIBCLANG )
    if ( APPLE )
      set( ENV_LIB_PATHS ENV DYLD_LIBRARY_PATH )
    elseif ( UNIX )
      set( ENV_LIB_PATHS ENV LD_LIBRARY_PATH )
    elseif ( WIN32 )
      set( ENV_LIB_PATHS ENV PATH )
    else ()
      set( ENV_LIB_PATHS "" )
    endif()
    # On Debian-based systems, llvm installs into /usr/lib/llvm-x.y.
    file( GLOB SYS_LLVM_PATHS "/usr/lib/llvm*/lib" )
    # Need TEMP because find_library does not work with an option variable
    find_library( TEMP clang
                  PATHS
                  ${ENV_LIB_PATHS}
                  /usr/lib
                  /usr/lib/llvm
                  ${SYS_LLVM_PATHS}
                  /Library/Developer/CommandLineTools/usr/lib
                  /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/lib )
    set( EXTERNAL_LIBCLANG_PATH ${TEMP} )
  else()
    # For Macs, we do things differently; look further in this file.
    if ( NOT APPLE )
      # Setting this to true makes sure that libraries we build will have our rpath
      # set even without having to do "make install"
      set( CMAKE_BUILD_WITH_INSTALL_RPATH TRUE )
      set( CMAKE_INSTALL_RPATH "\$ORIGIN" )
    endif()
  endif()

  set( LIBCLANG_TARGET ${EXTERNAL_LIBCLANG_PATH} )
  message(
    "Using external libclang: ${EXTERNAL_LIBCLANG_PATH}" )
else()
  set( LIBCLANG_TARGET )
endif()

if ( EXTRA_RPATH )
  set( CMAKE_INSTALL_RPATH "${EXTRA_RPATH}:${CMAKE_INSTALL_RPATH}" )
endif()

# Needed on Linux machines, but not on Macs and OpenBSD
if ( UNIX AND NOT ( APPLE OR SYSTEM_IS_OPENBSD ) )
  set( EXTRA_LIBS rt )
endif()

#############################################################################

# We don't actually need all of the files this picks up, just the ones needed by
# PythonSupport.cpp. But this is easier to maintain and dead code elemination
# will remove unused code.
file( GLOB CLIENT_SOURCES *.h *.cpp )
file( GLOB SERVER_SPECIFIC *ycm_core* )

if( SERVER_SPECIFIC )
  list( REMOVE_ITEM CLIENT_SOURCES ${SERVER_SPECIFIC} )
endif()

add_library( ${CLIENT_LIB} SHARED
             ${CLIENT_SOURCES}
           )

target_link_libraries( ${CLIENT_LIB}
                       ${Boost_LIBRARIES}
                       ${PYTHON_LIBRARIES}
                       ${EXTRA_LIBS}
                     )

#############################################################################

add_library( ${SERVER_LIB} SHARED
             ${SERVER_SOURCES}
           )

target_link_libraries( ${SERVER_LIB}
                       ${Boost_LIBRARIES}
                       ${PYTHON_LIBRARIES}
                       ${LIBCLANG_TARGET}
                       ${EXTRA_LIBS}
                     )

if( LIBCLANG_TARGET )
  # When building with MSVC, we need to copy libclang.dll instead of libclang.lib
  if( MSVC )
    add_custom_command(
      TARGET ${SERVER_LIB}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy "${PATH_TO_LLVM_ROOT}/bin/libclang.dll" "$<TARGET_FILE_DIR:${SERVER_LIB}>"
    )
  else()
    add_custom_command(
      TARGET ${SERVER_LIB}
      POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy "${LIBCLANG_TARGET}" "$<TARGET_FILE_DIR:${SERVER_LIB}>"
    )
  endif()
endif()

#############################################################################

# Convenience target that builds both support libs.
add_custom_target( ${PROJECT_NAME}
                   DEPENDS ${CLIENT_LIB} ${SERVER_LIB} )


#############################################################################

=== cpp/ycm/tests/CMakeLists.txt ===
# Copyright (C) 2011 Google Inc.
#
# This file is part of YouCompleteMe.
#
# YouCompleteMe is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# YouCompleteMe is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with YouCompleteMe.  If not, see <http://www.gnu.org/licenses/>.

project( ycm_core_tests )
cmake_minimum_required( VERSION 2.8 )

# The gtest library triggers these warnings, so we turn them off; it's not up to
# us to fix gtest warnings, it's up to upstream.
if ( COMPILER_IS_CLANG )
  set( CMAKE_CXX_FLAGS
    "${CMAKE_CXX_FLAGS} -Wno-long-long -Wno-variadic-macros -Wno-missing-field-initializers -Wno-unused-private-field -Wno-c++98-compat" )
endif()


option( USE_SYSTEM_GMOCK "Set to ON to use the system gmock/gtest libraries" OFF )

if ( USE_SYSTEM_GMOCK )
  set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )
  find_package( GTest REQUIRED )
  find_package( GMock REQUIRED )
else()
  add_subdirectory( gmock )
  set( GTEST_INCLUDE_DIRS ${gtest_SOURCE_DIR} ${gtest_SOURCE_DIR}/include )
  set( GMOCK_INCLUDE_DIRS ${gmock_SOURCE_DIR} ${gmock_SOURCE_DIR}/include )
  set( GTEST_LIBRARIES "" )
  set( GMOCK_LIBRARIES gmock )
endif()

include_directories(
  ${ycm_support_libs_SOURCE_DIR}
  )

include_directories(
  SYSTEM
  ${GMOCK_INCLUDE_DIRS}
  ${GTEST_INCLUDE_DIRS}
  )

link_directories(
  ${Boost_LIBRARY_DIRS}
  ${PYTHON_LIBRARIES}
  )

file( GLOB_RECURSE SOURCES *.h *.cpp )

# We don't want gmock sources in this target
file( GLOB_RECURSE to_remove gmock/*.h gmock/*.cpp CMakeFiles/*.cpp
  testdata/*.cpp testdata/*.h )

if( to_remove )
  list( REMOVE_ITEM SOURCES ${to_remove} )
endif()

if ( NOT USE_CLANG_COMPLETER )
  file( GLOB_RECURSE to_remove_clang ClangCompleter/*.h ClangCompleter/*.cpp )

  if( to_remove_clang )
    list( REMOVE_ITEM SOURCES ${to_remove_clang} )
  endif()
endif()

add_executable( ${PROJECT_NAME}
                ${SOURCES}
              )

target_link_libraries( ${PROJECT_NAME}
                       ${SERVER_LIB}
                       ${CLIENT_LIB}
                       ${GTEST_LIBRARIES}
                       ${GMOCK_LIBRARIES} )


if ( NOT CMAKE_GENERATOR_IS_XCODE )
  # The test executable expects a "testdata" dir in its working directory. Why?
  # Because there's NO reliable, cross-platform way of getting the directory in
  # which the executable is located.
  add_custom_target( copy_testdata
                    COMMAND cmake -E copy_directory
                    ${CMAKE_CURRENT_SOURCE_DIR}/testdata
                    ${CMAKE_CURRENT_BINARY_DIR}/testdata )
else()
  add_custom_target( copy_testdata
                    COMMAND cmake -E copy_directory
                    ${CMAKE_CURRENT_SOURCE_DIR}/testdata
                    ${CMAKE_CURRENT_BINARY_DIR}/Debug/testdata
                    COMMAND cmake -E copy_directory
                    ${CMAKE_CURRENT_SOURCE_DIR}/testdata
                    ${CMAKE_CURRENT_BINARY_DIR}/Release/testdata )

endif()

add_dependencies( ${PROJECT_NAME} copy_testdata )

## ycmd 0+20150804+git6f4dbb4

=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: Onur Aslan <onur@onur.im>
Build-Depends: debhelper (>= 9),
 cmake,
 dh-python,
 python-bottle,
 python-dev,
 python-flake8,
 python-hamcrest,
 python-jedi,
 python-nose,
 python-requests,
 python-waitress,
 python-webtest,
 golang [amd64 armel armhf i386],
 gocode [amd64 armel armhf i386],
 google-mock,
 libclang-3.6-dev | libclang-3.7-dev,
 libboost-python-dev,
 libboost-system-dev,
 libboost-filesystem-dev,
 libboost-regex-dev,
 libgtest-dev
X-Python-Version: >= 2.7
Standards-Version: 3.9.6
Homepage: https://github.com/Valloric/ycmd
Vcs-Git: git://anonscm.debian.org/collab-maint/ycmd.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ycmd.git

Package: ycmd
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${python:Depends},
 python-bottle,
 python-jedi,
 python-requests (>= 2.2.1),
 python-waitress
Recommends: vim-youcompleteme, gocode
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

BUILD_DIR            = $(CURDIR)/ycm_build
GIT_URL              = https://github.com/Valloric/ycmd.git
DEB_SOURCE           = $(shell dpkg-parsechangelog | grep Source: | sed -e 's/Source: //')
DEB_VERSION          = $(shell dpkg-parsechangelog | grep Version: | sed -e 's/Version: //')
DEB_UPSTREAM_COMMIT  = $(shell echo $(DEB_VERSION) | sed -rn 's/.*git([^-]*).*/\1/p')
DEB_UPSTREAM_VERSION = $(shell echo $(DEB_VERSION) | sed -e 's/-[^-]*$$//')
DEB_INSTALL_DIR      = $(CURDIR)/debian/$(DEB_SOURCE)


# Skip CsCompleter (OmniSharp) and TypeScript tests. This package doesn't
# support them.
# We are also skipping UnknownExtraConfException test.
# If ycmd package is installed in your system or
# /usr/lib/ycmd/ycm_extra_conf.py is present, UnknownExtraConfException is
# failing due to global_ycm_extra_conf defined in
# 02-generic-ycm-extra-conf-py.patch
EXCLUDE_TEST_PARAMS  = --exclude='.*CsCompleter.*' --exclude='.*TypeScript.*' --exclude='.*UnknownExtraConfException.*'

# This package is providing extra golang completion feature if golang and
# gocode packages are installed. *GoCodeCompleter* tests also require golang
# and gocode packages. gocode and golang is not available in every
# architecture. Skip GoCodeCompleter tests if DEB_BUILD_ARCH is not supported
# by golang
GO_DEP_ARCH          = $(shell dpkg-architecture -qDEB_BUILD_ARCH | egrep -x "(amd64|armel|armhf|i386)" > /dev/null; echo $$?)
ifneq ($(GO_DEP_ARCH),0)
  EXCLUDE_TEST_PARAMS += --exclude='.*GoCodeCompleter.*'
endif

%:
	dh $@ --with python2 --sourcedirectory=$(CURDIR)/cpp --builddirectory=$(BUILD_DIR) --parallel
      
override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_LIBCLANG=ON -DUSE_SYSTEM_BOOST=ON -DUSE_SYSTEM_GMOCK=ON

override_dh_auto_test:
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	cd $(BUILD_DIR)/ycm/tests && ./ycm_core_tests
	# Some tests only works if system language is UTF-8 based
	LC_ALL=C.UTF-8 ./run_tests.sh --skip-build -- --no-byte-compile $(EXCLUDE_TEST_PARAMS)
endif

override_dh_auto_clean:
	dh_auto_clean
	$(RM) -rfv *.so
	$(RM) -rfv $(BUILD_DIR)

override_dh_install:
	dh_install
	# Remove dot from .ycm_extra_conf.py
	mv $(DEB_INSTALL_DIR)/usr/lib/ycmd/.ycm_extra_conf.py \
       $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycm_extra_conf.py
	# No need to install tests
	$(RM) -rv $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycmd/completers/all/tests \
	          $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycmd/completers/completer_utils_test.py \
	          $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycmd/completers/cpp/tests \
	          $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycmd/completers/general/tests \
	          $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycmd/completers/go/tests \
	          $(DEB_INSTALL_DIR)/usr/lib/ycmd/ycmd/tests

get-orig-source:
	TMPDIR=`mktemp -d -t`; \
	git clone --recursive $(GIT_URL) $$TMPDIR; \
	cd $$TMPDIR; git checkout $(DEB_UPSTREAM_COMMIT); \
	tar -czvf $(CURDIR)/ycmd.orig.tar.gz .; \
	cd $(CURDIR); \
	dpt repack.sh --upstream-version $(DEB_UPSTREAM_VERSION) ycmd.orig.tar.gz ; \
	$(RM) ycmd.orig.tar.gz ; \
	$(RM) -r $$TMPDIR
